﻿Imports System.Runtime.InteropServices

Public Class Form1
    <StructLayout(LayoutKind.Sequential)> _
    Private Structure NativeMessage
        Public handle As IntPtr
        Public msg As UInteger
        Public wParam As IntPtr
        Public lParam As IntPtr
        Public time As UInteger
        Public p As System.Drawing.Point
    End Structure
    Private Declare Auto Function PeekMessage Lib "user32.dll" ( _
        ByRef lpMsg As NativeMessage, _
        ByVal hWnd As IntPtr, _
        ByVal wMsgFilterMin As UInteger, _
        ByVal wMsgFilterMax As UInteger, _
        ByVal flags As UInteger _
    ) As Boolean
    Private Const WM_MOUSEFIRST As UInteger = &H200
    Private Const WM_MOUSELAST As UInteger = &H20D
    Private Const PM_REMOVE As Integer = &H1

    ' Flush all pending mouse events.
    Private Sub FlushMouseMessages()
        Dim msg As NativeMessage
        ' Repeat until PeekMessage returns false.
        While (PeekMessage(msg, IntPtr.Zero, WM_MOUSEFIRST, WM_MOUSELAST, PM_REMOVE))

        End While
    End Sub

    ' Wait for 5 seconds.
    Private Sub btnWaitNow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWaitNow.Click
        ' None of these seem to work.
        'Me.Enabled = False
        'RemoveHandler btnWaitNow.Click, AddressOf btnWaitNow_Click
        btnWaitNow.Enabled = False
        Me.Cursor = Cursors.WaitCursor
        Application.DoEvents()

        lstMessages.Items.Add("Wait Now Start " + DateTime.Now.ToString())
        Refresh()
        System.Threading.Thread.Sleep(5000)
        lstMessages.Items.Add("Wait Now Stop  " + DateTime.Now.ToString())

        'Me.Enabled = True
        'AddHandler btnWaitNow.Click, AddressOf btnWaitNow_Click
        btnWaitNow.Enabled = True
        Me.Cursor = Cursors.Default
    End Sub

    ' Wait for 5 seconds and then flush the buffer.
    Private Sub btnWaitAndFlush_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWaitAndFlush.Click
        Me.Cursor = Cursors.WaitCursor
        lstMessages.Items.Add("Wait and Flush Start " + DateTime.Now.ToString())
        Refresh()

        System.Threading.Thread.Sleep(5000)

        lstMessages.Items.Add("Wait and Flush Stop  " + DateTime.Now.ToString())
        FlushMouseMessages()
        Me.Cursor = Cursors.Default
    End Sub
End Class
